/*
 * abasic
 * Copyright (C) 2007 m_inaba
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#if !defined(__COMMON)
#define __COMMON

//C^v^̃o[W
#define VERSION "\"0.1.0.13"


//Shift_jis̗ӓ_
//Shift_jis1oCgڂƂ肤͈́@0x81~0x9F,E0~FC
//Shift_jis2oCgڂƂ肤͈́@0x40~0xFC
#define shift_jis(c) (((unsigned char)0x81<=(unsigned char)c\
					 &&(unsigned char)0x9F>=(unsigned char)c)\
					 ||((unsigned char)0xE0<=(unsigned char)c\
					 &&(unsigned char)0xFC>=(unsigned char)c))


#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <math.h>
#include <stdlib.h>
#include <time.h>

#if defined _WIN32
	//Windows
	#define WINDOWS
#elif defined _WIN64
	//Windows
	#define WINDOWS
#elif defined __CYGWIN__
	//Windows + Cygwin
	#define CYGWIN
#else
	//Linux
	#define LINUX
#endif


#ifdef WINDOWS
	//Windows
	#include <conio.h>
	#include <windows.h>
	#pragma warning( disable : 4706 )
	#pragma warning( disable : 4710 )
	#pragma warning( disable : 4711 )
	#pragma warning( disable : 4786 )
	#pragma warning( disable : 4996 )
	#pragma warning(push,3) 
#else
	//Other
	#include <termios.h>
	#include <fcntl.h>
	#include <unistd.h>
	#define Sleep(x) usleep(1000*x)
#endif

//obt@̃TCY
#define MAX_STR_LEN (0x2000)
#define EOF			(-1)


//R[h̐؂ւ
#if defined WINDOWS
	//Windows
	//SHIFT_JISLɂ
	#define SHIFT_JIS
#elif defined CYGWIN
	//Windows + Cygwin
	//SHIFT_JISLɂ
	#define SHIFT_JIS
#else
	//Linux
#endif


//s̐؂ւ
#if defined WINDOWS
	//Windows
	#define OUTSTRING "%s\r\n"
#elif defined CYGWIN
	//Windows + Cygwin
	#define OUTSTRING "%s\r\n"
#else
	//Linux
	#define OUTSTRING "%s\n"
#endif



extern unsigned int interlope;

void setError(const char*str);
void _strcpy(char*a,const char*b);
char*_strstr(const char*a,const char*b);
char*_strstr2(const char*a,const char*b);
void trim_a(char*str);
void trim_a(char*str,char c);
void trim_r(char*str);
void trim_l(char*str);
void trim_c(char*str);
void trim_rl(char*str);
void trim_rlc(char*str);
int count_c(const char*str,const char c);
char*_strchop(char*str,const char c);
char*replace(char*buff,char*str,const char*a,const char*b);
char*match(const char *pat,const char *str,int*len);
void delcrlf(char*str);
void instcpy(char*out,const char*in);
void shell(char*str,int flag);

void nonblock_start();
int _getchar();
void nonblock_end();
unsigned char getHex2(const char*str);
unsigned char getOct3(const char*str);
void reverse(char*str);
void format(char*buf,char*str1,char*str2);
char*cut_func(char*str);
void default_func(char*defstr,const char*str);

#endif
//-------------------------------------------------------------------------------
